unit pasteAsWin;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, TextEditor;

type
  TpasteAsFrm = class(TForm)
    Label1: TLabel;
    mBefore: TMemo;
    Label2: TLabel;
    mAfter: TMemo;
    eBefore: TLabeledEdit;
    eAfter: TLabeledEdit;
    Label3: TLabel;
    cPresets: TComboBox;
    btnPaste: TButton;
    btnCancel: TButton;
    procedure cPresetsChange(Sender: TObject);
    procedure btnPasteClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  pasteAsFrm: TpasteAsFrm;

implementation

uses mainWin, Clipbrd;

{$R *.dfm}

procedure TpasteAsFrm.btnPasteClick(Sender: TObject);
const
  br = #13#10;
var
  strs: DynStringArray;
  S: string;
  i: Integer;
begin
  strs := Split(Clipboard.AsText, br);
  S := mBefore.Text + br;
  for i := 0 to high(strs) do
    S := S + eBefore.Text + strs[i] + eAfter.Text + br;
  S := S + mAfter.Text;
  RejbrandTextEditor.Editor.SelText := S;
end;

procedure TpasteAsFrm.cPresetsChange(Sender: TObject);
begin
  mBefore.Clear;
  mAfter.Clear;
  eBefore.Clear;
  eAfter.Clear;
  case cPresets.ItemIndex of
    0: // UL
      begin
        mBefore.Text := '<ul>';
        mAfter.Text := '</ul>';
        eBefore.Text := '  <li>';
        eAfter.Text := '</li>';
      end;
    1: // OL
      begin
        mBefore.Text := '<ol>';
        mAfter.Text := '</ol>';
        eBefore.Text := '  <li>';
        eAfter.Text := '</li>';
      end;
    2: // Ps
      begin
        eBefore.Text := '<p>';
        eAfter.Text := '</p>';
      end;
    3: // pre
      begin
        mBefore.Text := '<pre>';
        mAfter.Text := '</pre>';
        eBefore.Text := '';
        eAfter.Text := '';
      end;
  end;
end;

end.
