program rteditor;

uses
  SysUtils,
  Windows,
  Registry,
  Messages,
  Forms,
  mainWin in 'mainWin.pas' {RejbrandTextEditor},
  wwpWin in 'wwpWin.pas' {wwpFrm},
  sortWin in 'sortWin.pas' {sortFrm},
  historyWin in 'historyWin.pas' {historyFrm},
  replaceWin in 'replaceWin.pas' {replaceFrm},
  timeWin in 'timeWin.pas' {timeFrm},
  chrWin in 'chrWin.pas' {chrFrm},
  chrSearchResultWin in 'chrSearchResultWin.pas' {chrSearchResultFrm},
  pasteAsWin in 'pasteAsWin.pas' {pasteAsFrm},
  settingsWin in 'settingsWin.pas' {settingsFrm},
  printingWin in 'printingWin.pas' {printingFrm},
  selEncWin in 'selEncWin.pas' {selEncFrm},
  statisticsWin in 'statisticsWin.pas' {statisticsFrm},
  truncateWin in 'truncateWin.pas' {truncateFrm},
  filterWin in 'filterWin.pas' {filterFrm},
  notificationsWin in 'notificationsWin.pas' {notificationsFrm},
  advstatisticsWin in 'advstatisticsWin.pas' {advstatisticsFrm},
  chrSearchWin in 'chrSearchWin.pas' {chrSearchFrm};

{$R *.res}

var
  ReuseInstance: boolean;
  hwndPi: HWND;
  i, strlen: integer;
  s, buf: string;
  p: PChar;
  CDS: TCopyDataStruct;

const
  ValueReuseInstance = 'ReuseInstance';

begin

  ReuseInstance := false;
  with TRegistry.Create do
    try
      RootKey := HKEY_CURRENT_USER;
      if OpenKey('\Software\Rejbrand\Rejbrand Text Editor', false) then
        if ValueExists(ValueReuseInstance) then
          ReuseInstance := ReadBool(ValueReuseInstance)
    finally
      Free;
    end;

  if ReuseInstance then
  begin
    hwndPi := FindWindow(PChar(RTE_WNDCLASS_NAME), nil);
    if hwndPi <> 0 then
    begin
      // Is the old instance available to be used as a target?
      // For instance, if the previous instance is elevated and we are not,
      // we cannot send it messages. Also, if it has a modal dialog open,
      // such as a save dialog, we don't want to insert a new tab behind its
      // back.
      if SendMessage(hwndPi, WM_QUERYPREVINST, 0, 0) = PREVINST_READY then
      begin

        strlen := 0;
        for i := 1 to ParamCount do
          inc(strlen, ParamStr(i).Length + 1);
        inc(strlen, 1);

        SetLength(buf, strlen);
        p := PChar(buf);
        for i := 1 to ParamCount do
        begin
          s := ParamStr(i);
          CopyMemory(p, PChar(s), (s.Length + 1) * sizeof(char));
          inc(p, s.Length + 1);
        end;
        p^ := #0;

        FillChar(CDS, sizeof(CDS), 0);
        CDS.dwData := RTE_COPYDATA_FILEARRAY;
        CDS.cbData := Length(buf) * sizeof(char);
        CDS.lpData := PChar(buf);

        if SendMessage(hwndPi, WM_COPYDATA, 0, NativeInt(@CDS)) = 1 then
        begin
          SetForegroundWindow(hwndPi);
          Exit;
        end;

        s := '';
        buf := '';

      end;
    end;
  end;

  Application.Initialize;
  Application.MainFormOnTaskbar := True;
  Application.Title := 'Rejbrand Text Editor';
  Application.CreateForm(TRejbrandTextEditor, RejbrandTextEditor);
  Application.CreateForm(TchrFrm, chrFrm);
  Application.CreateForm(TprintingFrm, printingFrm);
  Application.CreateForm(TnotificationsFrm, notificationsFrm);
  Application.CreateForm(TreplaceFrm, replaceFrm);
  Application.Run;

end.
