unit selEncWin;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, TextEditor, TextEncodings;

type
  TselEncFrm = class(TForm)
    lbEncodings: TListBox;
    stEncodings: TStaticText;
    stPreview: TStaticText;
    tePreview: TTextEditor;
    btnOk: TButton;
    btnCancel: TButton;
    procedure lbEncodingsClick(Sender: TObject);
    procedure lbEncodingsKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnOkClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    procedure CheckBtnOkEnabled;
    procedure DoPreview;
    { Private declarations }
  public
    { Public declarations }
    FFileName: TFileName;
    FProbableEncoding: TTextEncoding;
    FPossibleEncodings: TTextEncodings;
    FSelectedEncoding: TTextEncoding;
  end;

var
  selEncFrm: TselEncFrm;

implementation

{$R *.dfm}

procedure TselEncFrm.lbEncodingsClick(Sender: TObject);
begin
  CheckBtnOkEnabled;
  DoPreview;
end;

procedure TselEncFrm.lbEncodingsKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  CheckBtnOkEnabled;
  DoPreview;
end;

procedure TselEncFrm.btnOkClick(Sender: TObject);
var
  e: TTextEncoding;
begin
  for e in FPossibleEncodings do
    if SameText(TextEncodingsStrs[e], lbEncodings.Items[lbEncodings.ItemIndex]) then
    begin
      FSelectedEncoding := e;
      break;
    end;
end;

procedure TselEncFrm.CheckBtnOkEnabled;
begin
  btnOk.Enabled := lbEncodings.ItemIndex <> -1;
end;

procedure TselEncFrm.DoPreview;
var
  e: TTextEncoding;
begin
  if lbEncodings.ItemIndex = -1 then Exit;

  for e in FPossibleEncodings do
    if SameText(TextEncodingsStrs[e], lbEncodings.Items[lbEncodings.ItemIndex]) then
    begin
      tePreview.LoadFromFile(FFileName, GetVCLEncoding(e));
      break;
    end;
end;

procedure TselEncFrm.FormShow(Sender: TObject);
var
  e: TTextEncoding;
  i: Integer;
begin
  lbEncodings.Items.BeginUpdate;
  lbEncodings.Items.Clear;
  for e in FPossibleEncodings do
    lbEncodings.Items.Add(TextEncodingsStrs[e]);
  lbEncodings.Items.EndUpdate;
  CheckBtnOkEnabled;

  for i := 0 to lbEncodings.Count - 1 do
    if SameStr(TextEncodingsStrs[FProbableEncoding], lbEncodings.Items[i]) then
    begin
      lbEncodings.ItemIndex := i;
      CheckBtnOkEnabled;
      DoPreview;
      break;
    end;
end;

end.
